## 测试环境
* VPS*2：
    - CPU Model name:Intel Core Processor (Haswell, no TSX, IBRS)*1 
    - CPU MHz: 2399.996
    - 1G内存
    - 10Gbps上下行带宽
    - 公网IP
* 系统：Debian 10

## 测试工具
* v2ray 4.32.0
* iperf3.6

## 测试时间
2020.10

## 测试一
- 因为目前DS的listen只支持VLESS,vmess,trojan,所以选择使用将VLESS数据发送至v2ray的trojan协议的inbound,然后fallback到VLESS的inbound的模式.
- AB两台VPS
  - A iperf客户端, 负责产生VLESS数据，发送给B
  - B 负责使用v2ray以trojan协议的inbound接收数据后fallback.fallback至以各种模式监听的VLESS的inbound,然后发送给iperf服务端.
- 各测试区别仅在于fallback的地址模式和对应的fallback的VLESS inbound的listen模式不同.
- 四种模式:tcp端口、domainsocket、abstract domainsocket和padding abstract domainsocket
- 测试时候B的CPU负荷满
- 测试时长一分钟,多次测试取平均值

* 数据流向：
  - iperf client-->A,inbound(dokodemo-door),outbound(VLESS over TCP)  
    -->B,inbound(v2ray'trojan over TCP),fallback(VLESS over TCP--以各种监听方式)  
    -->iperf server

### 测试数据

-|	TCP端口|	domainsocket|	abstract domainsocket|	padding abstract domainsocket
---- | ---| ---| ---| ---
sender|	2.92Gbps|	723Mbps|	724Mbps	|705Mbps
receiver|	2.90Gbps|	714Mbps|	718Mbps	|698Mbps

* DS性能损失非常大.且padding abstract domainsocket为何似乎略低一点?

## 测试二

nginx转发至v2ray的三种模式测试
  - TCP 端口转发
  - DS 转发
  - TCP 端口转发+proxy protocol

### 测试数据
  1. TCP 端口转发
  - iperf client-->A,inbound(dokodemo-door),outbound(VLESS over TCP)  
    -->B,nginx stream proxy pass(TCP)  
    -->B,inbound(VLESS over TCP),outbound(freedom)  
    -->iperf server
    ```
    2.69 Gbits/sec                sender
    2.67 Gbits/sec                  receiver
    ```
    * 此数据应亦可对比测试一中以TCP端口模式fallback 至 VLESS的数值,仅nginx转发和fallback不同
  
  2. DS 转发
  - iperf client-->A,inbound(dokodemo-door),outbound(VLESS over TCP)  
    -->B,nginx stream proxy pass(DS)  
    -->B,inbound(VLESS over TCP),outbound(freedom)  
    -->iperf server
    ```
    756 Mbits/sec               sender
    769 Mbits/sec                  receiver
    ```
    * DS性能损失巨大
    * 此数据应亦可对比测试一中以DS模式fallback 至 VLESS的数值,仅nginx转发和fallback不同
  3. TCP 端口转发+proxy protocol
  - iperf client-->A,inbound(dokodemo-door),outbound(VLESS over TCP)  
    -->B,nginx stream proxy pass(TCP)+proxy protocol  
    -->B,inbound(VLESS over TCP),outbound(freedom)  
    -->iperf server
    ```
    879 Mbits/sec               sender
    848 Mbits/sec                  receiver
    ```
    * proxy protocol性能损失似乎也很大

## 测试三

iperf数据直接通过VLESS fallback 和 nginx stream proxy pass 的对比测试

  - iperf client-->A,inbound(dokodemo-door),outbound(freedom)  
    -->B,inbound(VLESS over TCP),fallback  
    -->iperf server
    ```
    3.44 Gbits/sec                sender
    3.43 Gbits/sec                  receiver
    ```
    * 对比测试一的TCP fallback模式数据,应能大致看出VLESS带来的性能损耗.    
    
  - iperf client-->A,inbound(dokodemo-door),outbound(freedom)  
    -->B,nginx stream proxy pass(TCP)    
    -->iperf server  
    ```
    3.20 Gbits/sec               sender
    3.19 Gbits/sec                  receiver
    ```
