## 测试环境
* VPS*4：
    - CPU Model name:Intel Xeon Processor (Skylake, IBRS)*1 
    - CPU MHz: 2593.904
    - 支持AES指令
    - 2G内存
    - 10Gbps上下行带宽
    - 公网IP
* 系统：Debian 10

## 测试工具
* v2ray 4.32.0(with VLESS XTLS ReadV)
* ethr

## 测试时间
2020.11

## 测试方式
* 因为测试较复杂,本地回环测试甚至2台独立机器测试会导致各种因素互相影响较大，不易控制流程中各个环节和因素，也无法进行细致比较分析
* 因此测试将数据流向的各个环节完全拆开，并且使用CPUlimit来控制各环节的CPU使用上限
  * 令第一次TLS加密解密对测试无影响,变量仅为二次加密
  * 可以模拟使用中间硬件的实用场景
  * 可以去除各种因素相互影响
  * 可以控制性能瓶颈进行不同测试对照
  * 可以分别分析各数据处理环节对性能的影响
* 使用4台VPS功能如下，以下简单命名4台VPS为，ABCD
  - A 负责使用测试工具客户端产生TLS加密数据，发送给B
  - B 负责使用v2ray以各种方式对A产生的数据进行处理并转发给C（无二次加密/TLS/XTLS等方式），也即类似一些用户场景的中间设备。
  - C 负责使用v2ray接收和以各种方式处理B的数据（无二次加密/TLS/XTLS等方式），发送给D
  - D 负责处理和接收数据并发送至测试工具服务端
* 使用CPUlimit控制各个数据处理节点的CPU使用上限
  - 测试的主要目的是，对比BC处理过程中无二次加密/TLS/XTLS的性能
  - 因此，AD的CPU上限不进行限制，只进行BC的CPU限制，尽量保证对非上限评估的测试中，AD的CPU负荷不会满载（限制BC为瓶颈，也同时使AD不会成为瓶颈）
* 多线程使用ethr(10)

## 测试说明
  * 此测试去掉了关闭特殊功能
  * 以下单位均为Mbps
  * 1K,2K,4K,16K指TLS record大小
  * none指没有TLS或者加密,即纯TCP模式裸奔(VLESS over TCP),可以认为是测试模式的上限参考值.
  * 数据流向：
   - A,ethr client  
  -->B,inbound(dokodemo-door),outbound(VLESS over TCP/with TLS/with XTLS)  
  -->C,inbound(VLESS over TCP/with TLS/with XTLS),outbound(freedom)  
  -->D,ethr server
  * 本次测试硬件和之前测试不同,数据没有横向对比的意义

## 测试数据
1. 限制C的性能为20%时

ReadV|	1K|	2K|	4K|	16K
---- | ---| ---| ---| ---
none|	**730.9**|**816.5**|	**825.5**|	**860.2**
TLS	|402.6|	394.6	|439.4|	433.6
XTLS(origin)|	357.3|	381.6|448.5|	507.7
XTLS(direct)|	**620**|	**685.6**|	**716.5**|	**788.8**


4.32.0|	1K|	2K|	4K|	16K
---- | ---| ---| ---| ---
none|	744|	812.2|	826|	879.9
TLS	|391.4|	426.1	|421.3|	454.6
XTLS(origin)|	372|387.7	|453.3|	533.3
XTLS(direct)|	438.4|448.2	|	472.5|	498.9

1. 限制B的性能为20%时

ReadV|	1K|	2K|	4K|	16K
---- | ---| ---| ---| ---
none|	-|	-|	-|	967.9
TLS	|-|	-	|-|	500.2
XTLS(origin)|	-|	-|-|	615.2
XTLS(direct)|	-|	-|	-|	663.7


4.32.0|	1K|	2K|	4K|	16K
---- | ---| ---| ---| ---
none|	-|	-|	-|	958.6
TLS	|-|	-	|-|	525.3
XTLS(origin)|	-|	-|-|	619.7
XTLS(direct)|	-|	-|	-|	628.8

## 结论
  
  * 测试模式中数据未能100%被XTLS处理,并且不可知多少部分被XTLS处理,但去掉关闭特殊功能后,可以观察得到=10的输出仅在测试开始,并且后续10个连接均很快进入流控模式.所以应该可以大致认为未被XTLS处理的数据并不多.
  * 4.32.0的direct表现与[第三次测试](https://github.com/badO1a5A90/v2ray-doc/blob/master/performance_test/XTLS/VLESS_XTLS_3_test_03.md)一致,当限制C的性能时,大多数时候都高于origin,在16K时候略低于origin.
  * readV模式:
    * **当限制C时(即接收为瓶颈),ReadV模式强悍,提升至与纯TCP模式84%-91%的速率,考虑到未能100%被XTLS处理的因素,大致可以认为是几乎和none(裸奔)持平的水准..**
    * 当限制B时(即发送为瓶颈),ReadV模式和普通版本的direct表现基本相当(略高可能属于测试浮动).
  * XTLS相对于TLS能提升多少与硬件相关并没有标准(性能越低提升越高,无硬解更能多一次翻倍提升),**若XTLS表现能接近纯TCP,应该可认为已经达到v2ray框架下目前所有协议/配置组合所能达到的极限值(接近裸奔)**
  * 补充:关闭特殊功能在实际使用中,正常的TLS数据流几乎不会触发
